diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/BlockDispenser.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/DispenserBlock.java
rename to src/main/java/net/minecraft/core/block/BlockDispenser.java
index e79a0a7c5..cbac228c2 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockDispenser.java
@@ -2,8 +2,8 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.*;
@@ -16,10 +16,10 @@ import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class DispenserBlock extends VeryRotatableEntityBlock
+public class BlockDispenser extends BlockTileEntityVeryRotatable
 {
     public static final int MASK_POWERED = 0b0000_1000;
-	public DispenserBlock(String key, String namespaceId, int id)
+	public BlockDispenser(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.stone);
     }
@@ -38,20 +38,20 @@ public class DispenserBlock extends VeryRotatableEntityBlock
             return true;
         } else
         {
-            DispenserBlockEntity dispenserBlockEntity = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
-            player.displayDispenserScreen(dispenserBlockEntity);
+            TileEntityDispenser tileEntityDispenser = (TileEntityDispenser)world.getBlockEntity(x, y, z);
+            player.displayDispenserScreen(tileEntityDispenser);
             return true;
         }
     }
 
     private void dispenseItem(World world, int x, int y, int z, Random random)
     {
-        Direction direction = VeryRotatableEntityBlock.metaToDirection(world.getBlockMetadata(x, y, z));
+        Direction direction = BlockTileEntityVeryRotatable.metaToDirection(world.getBlockMetadata(x, y, z));
         int xOffset = direction.getOffsetX();
         int yOffset = direction.getOffsetY();
         int zOffset = direction.getOffsetZ();
 
-        DispenserBlockEntity tileEntity = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
+        TileEntityDispenser tileEntity = (TileEntityDispenser)world.getBlockEntity(x, y, z);
         ItemStack itemStack = tileEntity.getRandomStackFromInventory();
         double px = (double)x + (double)xOffset * 0.6D + 0.5D;
         double py = (double)y + (double)yOffset * 0.6D + 0.5D;
@@ -71,7 +71,7 @@ public class DispenserBlock extends VeryRotatableEntityBlock
             else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id)
             {
 
-                ArrowProjectile arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ArrowProjectile(world, px, py, pz, 0) : new GoldenArrowProjectile(world, px, py, pz);
+                ProjectileArrow arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ProjectileArrow(world, px, py, pz, 0) : new ProjectileArrowGolden(world, px, py, pz);
                 arrow.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
                 arrow.setDoesArrowBelongToPlayer(true);
                 world.entityJoinedWorld(arrow);
@@ -79,14 +79,14 @@ public class DispenserBlock extends VeryRotatableEntityBlock
             }
             else if (itemStack.itemID == Items.AMMO_CHARGE_EXPLOSIVE.id)
             {
-                CannonballProjectile cannonballProjectile = new CannonballProjectile(world, px, py, pz);
-                cannonballProjectile.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
-                world.entityJoinedWorld(cannonballProjectile);
+                ProjectileCannonball projectileCannonball = new ProjectileCannonball(world, px, py, pz);
+                projectileCannonball.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
+                world.entityJoinedWorld(projectileCannonball);
                 world.playBlockEvent(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
             else
             {
-                ItemEntity item = new ItemEntity(world, px, py - 0.3D, pz, itemStack);
+                EntityItem item = new EntityItem(world, px, py - 0.3D, pz, itemStack);
                 double randOffset = random.nextDouble() * 0.1D + 0.2D;
                 item.xd = (double)xOffset * randOffset;
                 item.yd = (double)yOffset + 0.2D;
@@ -122,9 +122,9 @@ public class DispenserBlock extends VeryRotatableEntityBlock
     }
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new DispenserBlockEntity();
+        return new TileEntityDispenser();
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/BlockDoor.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/DoorBlock.java
rename to src/main/java/net/minecraft/core/block/BlockDoor.java
index c829e33c5..b5f77f3d4 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockDoor.java
@@ -3,12 +3,12 @@ package net.minecraft.core.block;
 import java.util.Random;
 import java.util.function.Supplier;
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -28,7 +28,7 @@ import org.jetbrains.annotations.Nullable;
 //            Item, AxisAlignedBB, Player, Vec3D,
 //            MovingObjectPosition
 
-public class DoorBlock extends Block implements IPaintable
+public class BlockDoor extends Block implements IPaintable
 {
     public static final int MASK_ROTATION = 0b0000_0011;
     public static final int MASK_OPENED = 0b0000_0100;
@@ -39,7 +39,7 @@ public class DoorBlock extends Block implements IPaintable
     @Nullable
     public final Supplier<Item> droppedItem;
 	
-	public DoorBlock(String key, String namespaceId, int id, Material material, boolean isTop, boolean requireTool, @Nullable Supplier<Item> droppedItem)
+	public BlockDoor(String key, String namespaceId, int id, Material material, boolean isTop, boolean requireTool, @Nullable Supplier<Item> droppedItem)
     {
         super(key, namespaceId, id, material);
         this.isTop = isTop;
@@ -153,13 +153,13 @@ public class DoorBlock extends Block implements IPaintable
         int l = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof DoorBlock)
+            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
             {
             	Block.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
             }
             return true;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
+        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ MASK_OPENED);
         }
@@ -170,7 +170,7 @@ public class DoorBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         onBlockRightClicked(world, x, y, z, null, direction.getSide(), 0.5, 0.5);
     }
 
@@ -182,9 +182,9 @@ public class DoorBlock extends Block implements IPaintable
         
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof DoorBlock)
+            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
             {
-            	((DoorBlock)Block.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
+            	((BlockDoor)Block.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
             }
             return;
         }
@@ -193,7 +193,7 @@ public class DoorBlock extends Block implements IPaintable
         {
             return;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
+        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, meta ^ MASK_OPENED);
         }
@@ -209,7 +209,7 @@ public class DoorBlock extends Block implements IPaintable
         if(isTop)
         {
         	Block otherBlock = Block.blocksList[world.getBlockId(x, y - 1, z)];
-            if(!(otherBlock instanceof DoorBlock))
+            if(!(otherBlock instanceof BlockDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
             }
@@ -221,7 +221,7 @@ public class DoorBlock extends Block implements IPaintable
         {
             boolean flag = false;
         	Block otherBlock = Block.blocksList[world.getBlockId(x, y + 1, z)];
-            if(!(otherBlock instanceof DoorBlock))
+            if(!(otherBlock instanceof BlockDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
                 //dropBlockAsItem(world, i, j, k, i1);
@@ -232,7 +232,7 @@ public class DoorBlock extends Block implements IPaintable
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 world.setBlockWithNotify(x, y, z, 0);
                 flag = true;
-                if(otherBlock instanceof DoorBlock)
+                if(otherBlock instanceof BlockDoor)
                 {
                     world.setBlockWithNotify(x, y + 1, z, 0);
                 }
@@ -270,7 +270,7 @@ public class DoorBlock extends Block implements IPaintable
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (droppedItem == null) return null;
         if (requireTool && dropCause != EnumDropCause.IMPROPER_TOOL)
diff --git a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java b/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
similarity index 89%
rename from src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
rename to src/main/java/net/minecraft/core/block/BlockDoorPainted.java
index 59f2b93c6..08e27fca4 100644
--- a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -8,12 +8,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class DoorPaintedBlock extends DoorBlock implements IPainted {
-    public DoorPaintedBlock(String key, String namespaceId, int id, Material material, boolean isTop) {
+public class BlockDoorPainted extends BlockDoor implements IPainted {
+    public BlockDoorPainted(String key, String namespaceId, int id, Material material, boolean isTop) {
         super(key, namespaceId, id, material, isTop, false, null);
     }
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return new ItemStack[] { new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (meta >> 4 & 0xF)) };
     }
diff --git a/src/main/java/net/minecraft/core/block/EdibleBlock.java b/src/main/java/net/minecraft/core/block/BlockEdible.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/EdibleBlock.java
rename to src/main/java/net/minecraft/core/block/BlockEdible.java
index 851f04165..b9eb9c8bf 100644
--- a/src/main/java/net/minecraft/core/block/EdibleBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockEdible.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -12,13 +12,13 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public abstract class EdibleBlock extends Block {
+public abstract class BlockEdible extends Block {
     @NotNull
     private final Supplier<Item> itemSupplier;
     public int maxBites;
     public int healAmount;
 
-    public EdibleBlock(String key, String namespaceId, int id, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
+    public BlockEdible(String key, String namespaceId, int id, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
     {
         super(key, namespaceId, id, Material.cake);
         this.maxBites = maxBites;
@@ -28,7 +28,7 @@ public abstract class EdibleBlock extends Block {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK || meta == 0)
         {
diff --git a/src/main/java/net/minecraft/core/block/FarmlandBlock.java b/src/main/java/net/minecraft/core/block/BlockFarmland.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/FarmlandBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFarmland.java
index 8fbaf76fa..b076f8af6 100644
--- a/src/main/java/net/minecraft/core/block/FarmlandBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFarmland.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
@@ -18,11 +18,11 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class FarmlandBlock extends Block implements IBonemealable
+public class BlockFarmland extends Block implements IBonemealable
 {
 	public static final int MASK_FERTILIZED = 0b0001_0000;
 	public static final int MASK_WET = 0b0000_1111;
-	public FarmlandBlock(String key, String namespaceId, int id)
+	public BlockFarmland(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id, Material.dirt);
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
@@ -78,7 +78,7 @@ public class FarmlandBlock extends Block implements IBonemealable
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
 		switch (dropCause)
 		{
@@ -196,7 +196,7 @@ public class FarmlandBlock extends Block implements IBonemealable
 					{
 						//...And the block is next to another wet mud block, it can become wet
 						int bID = world.getBlockId(x1, y1, z1);
-						if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && FarmlandBlock.isWet(world.getBlockMetadata(x1, y1, z1))))
+						if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && BlockFarmland.isWet(world.getBlockMetadata(x1, y1, z1))))
 						{
 							return true;
 						}
diff --git a/src/main/java/net/minecraft/core/block/FenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFence.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/FenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFence.java
index 5b6c71208..a4b897264 100644
--- a/src/main/java/net/minecraft/core/block/FenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFence.java
@@ -12,7 +12,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 
-public class FenceBlock extends Block implements IPaintable
+public class BlockFence extends Block implements IPaintable
 {
 //    private static final List<BoundingVolume> selectionVolumes = new ArrayList<>();
 //
@@ -58,7 +58,7 @@ public class FenceBlock extends Block implements IPaintable
 //        selectionVolumes.add(newVolume);
 //    }
 
-    public FenceBlock(String key, String namespaceId, int id)
+    public BlockFence(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
diff --git a/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
index ebea485b6..a656ae989 100644
--- a/src/main/java/net/minecraft/core/block/ChainlinkFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
@@ -2,13 +2,12 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class ChainlinkFenceBlock extends ThinFenceBlock
+public class BlockFenceChainlink extends BlockFenceThin
 {
-    public ChainlinkFenceBlock(String key, String namespaceId, int id, Material material)
+    public BlockFenceChainlink(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
diff --git a/src/main/java/net/minecraft/core/block/FenceGateBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/FenceGateBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceGate.java
index 6c0f4e947..3b9ed0287 100644
--- a/src/main/java/net/minecraft/core/block/FenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -17,12 +17,12 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class FenceGateBlock extends Block implements IPaintable
+public class BlockFenceGate extends Block implements IPaintable
 {
     public static final int MASK_DIRECTION = 0b0000_0011;
     public static final int MASK_OPEN = 0b0000_0100;
 
-    public FenceGateBlock(String key, String namespaceId, int id)
+    public BlockFenceGate(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.wood);
     }
@@ -137,7 +137,7 @@ public class FenceGateBlock extends Block implements IPaintable
     }
 
     @Override
-    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         onBlockRightClicked(world, x, y, z, null, direction.getSide(), 0.5, 0.5);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java
index 1dd83c3d5..ec37c65b9 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -9,10 +9,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
+public class BlockFenceGatePainted extends BlockFenceGate implements IPainted
 {
 	public static final int MASK_COLOR = 0b1111_0000;
-	public PaintedFenceGateBlock(String key, String namespaceId, int id)
+	public BlockFenceGatePainted(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id);
 	}
@@ -23,7 +23,7 @@ public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
 		return new ItemStack[] { new ItemStack(this, 1, meta & MASK_COLOR) };
 	}
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFencePainted.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFencePainted.java
index 006bb02d8..8bb402d15 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFencePainted.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -9,9 +9,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class PaintedFenceBlock extends FenceBlock implements IPainted
+public class BlockFencePainted extends BlockFence implements IPainted
 {
-	public PaintedFenceBlock(String key, String namespaceId, int id)
+	public BlockFencePainted(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id);
 	}
@@ -22,7 +22,7 @@ public class PaintedFenceBlock extends FenceBlock implements IPainted
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
 		return new ItemStack[] { new ItemStack(this, 1, meta & 0x0F) };
 	}
diff --git a/src/main/java/net/minecraft/core/block/SteelFenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/SteelFenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceSteel.java
index 5d84e70cd..54211a1ef 100644
--- a/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceSteel.java
@@ -1,17 +1,17 @@
-package net.minecraft.core.block;
-
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.world.WorldSource;
-
-public class SteelFenceBlock extends ThinFenceBlock {
-    public SteelFenceBlock(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
-    }
-
-    @Override
-    public boolean canConnectTo(WorldSource world, int x, int y, int z) {
-        int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial.isMetal()));
-    }
-}
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockFenceSteel extends BlockFenceThin {
+    public BlockFenceSteel(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
+    }
+
+    @Override
+    public boolean canConnectTo(WorldSource world, int x, int y, int z) {
+        int id = world.getBlockId(x, y, z);
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial.isMetal()));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/ThinFenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceThin.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/ThinFenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceThin.java
index 9252fc551..ece295b00 100644
--- a/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceThin.java
@@ -5,9 +5,9 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public abstract class ThinFenceBlock extends Block
+public abstract class BlockFenceThin extends Block
 {
-    public ThinFenceBlock(String key, String namespaceId, int id, Material material)
+    public BlockFenceThin(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
diff --git a/src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java b/src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java
index 1dde81004..d8b13eab3 100644
--- a/src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java
@@ -2,12 +2,11 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 
-public class PaperWallFenceBlock extends ThinFenceBlock
+public class BlockFenceWallPaper extends BlockFenceThin
 {
-    public PaperWallFenceBlock(String key, String namespaceId, int id, Material material)
+    public BlockFenceWallPaper(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
diff --git a/src/main/java/net/minecraft/core/block/FireBlock.java b/src/main/java/net/minecraft/core/block/BlockFire.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/FireBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFire.java
index df2735cd6..c9c2edc0d 100644
--- a/src/main/java/net/minecraft/core/block/FireBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFire.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.sound.SoundCategory;
@@ -13,7 +13,7 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class FireBlock extends Block {
+public class BlockFire extends Block {
 	public static final int FLAME_INSTANT = 60;
 	public static final int FLAME_EASY = 30;
 	public static final int FLAME_MEDIUM = 15;
@@ -26,14 +26,14 @@ public class FireBlock extends Block {
 	private static final int[] flameChance = new int[Block.blocksList.length];
 	private static final int[] burnChance = new int[Block.blocksList.length];
 
-	public FireBlock(String key, String namespaceId, int id) {
+	public BlockFire(String key, String namespaceId, int id) {
 		super(key, namespaceId, id, Material.fire);
 		setTicking(true);
 		setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
 	{
 		return null;
 	}
@@ -72,8 +72,8 @@ public class FireBlock extends Block {
 	}
 
 	public static void setFlammable(int id, int flameChance, int burnChance) {
-		FireBlock.flameChance[id] = flameChance;
-		FireBlock.burnChance[id] = burnChance;
+		BlockFire.flameChance[id] = flameChance;
+		BlockFire.burnChance[id] = burnChance;
 	}
 
 	@Override
@@ -210,7 +210,7 @@ public class FireBlock extends Block {
 			}
 			
 			if (isTNT) {
-				TNTBlock TNTBlock = (TNTBlock) Blocks.TNT;
+				BlockTNT TNTBlock = (BlockTNT) Blocks.TNT;
 				TNTBlock.ignite(world, x, y, z, true);
 			}
 		}
@@ -271,7 +271,7 @@ public class FireBlock extends Block {
 
 	protected int getBurnResultId(World world, int x, int y, int z) {
 		int id = world.getBlockId(x, y, z);
-		Block stoneBlock = MossBlock.getStoneBlock(id);
+		Block stoneBlock = BlockMoss.getStoneBlock(id);
 		if (stoneBlock != null) {
 			return stoneBlock.id;
 		}
@@ -281,7 +281,7 @@ public class FireBlock extends Block {
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
 		if (world.getBlockId(x, y - 1, z) == Blocks.OBSIDIAN.id
-				&& ((PortalBlock) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z, null)) {
+				&& ((BlockPortal) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z, null)) {
 			return;
 		}
 		if (!world.isBlockNormalCube(x, y - 1, z) && !canNeighborCatchFire(world, x, y, z)) {
